/*
 * Pi Gian Domenico Marchi
 * 20.02.2018 18:06
 * Misura tensione in aria con TL081 e Blynk
  *//*************************************************************
  Download latest Blynk library here:
    https://github.com/blynkkk/blynk-library/releases/latest

  Blynk is a platform with iOS and Android apps to control
  Arduino, Raspberry Pi and the likes over the Internet.
  You can easily build graphic interfaces for all your
  projects by simply dragging and dropping widgets.

    Downloads, docs, tutorials: http://www.blynk.cc
    Sketch generator:           http://examples.blynk.cc
    Blynk community:            http://community.blynk.cc
    Follow us:                  http://www.fb.com/blynkapp
                                http://twitter.com/blynk_app

  Blynk library is licensed under MIT license
  This example code is in public domain.

 *************************************************************
  This example runs directly on ESP8266 chip.

  Note: This requires ESP8266 support package:
    https://github.com/esp8266/Arduino

  Please be sure to select the right ESP8266 module
  in the Tools -> Board menu!

  Change WiFi ssid, pass, and Blynk auth token to run :)
  Feel free to apply it to any other example. It's simple!
 *************************************************************/

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <SimpleTimer.h>  // per calcolo attesa ciclo ripetitivo

float media = 0;  // for calculate the media of tension
float ciclo = 0;   // per conteggio cicli eseguiti
float valore = 0; // per calcolare la tensione
float mV = 0;  // tensione in millivolt
int valueA0 = 0; // valore letto sulla porta A0
// You should get Auth Token in the Blynk App.
// Go to the Project Settings (nut icon).
char auth[] = "60a4f3fbc9b7410d83f."; // inserisci il codice ottenuto


// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "TIM-.."; // inserisci la tua rete
char pass[] = "wGggn2lBH4DibrMI.."; // inserisci la password tua rete


SimpleTimer timer; // definiamo un oggetto timer di tipo SimpleTimer


void setup()
{
  // Debug console
  Serial.begin(115200);
  Blynk.begin(auth, ssid, pass);  // connessione a Wifi e Blynk
  timer.setInterval(200L, inviaMisura); // 200L = 200 msecondi
 
}


void inviaMisura()
  {
    valueA0 = analogRead(A0);
    mV = (valueA0 * 3070 / 1024); // x taratura usare 3070 mvolt
    media = media + mV;
    ciclo = ciclo + 1;
  }
  
void loop()
{
  if (ciclo < 900) // 900= ciclo di 3 minuti esegue media 900 letture
  {
  // non esegue nulla ed esce ripetendo un ciclo e i comandi sucessivi
  }
   else
   {
   valore =  media / ciclo;
   //Serial.println(valore); //Serial.println("mV")
   Blynk.virtualWrite(V1, valore); // invia al pin virtuale Blink 1 il valore medio della tensione in millivolt
   ciclo = 0;
   media = 0;
   }
    
  Blynk.run();  // esegue Blynk
  timer.run(); // esegue il timer
}  
